unit Unit2;

interface

uses
{ Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,IpTypes,
  ComObj, ExtCtrls,IpHlpApi,ActiveX,
   OpcLabs_BaseLib_TLB,
  OpcLabs_BaseLibForms_TLB,
  OpcLabs_EasyOpcClassic_TLB,
  OpcLabs_EasyOpcUA_TLB;
 }

  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls,IpTypes,IpHlpApi,ActiveX,
  OpcLabs_BaseLib_TLB,
  OpcLabs_BaseLibForms_TLB,
  OpcLabs_EasyOpcClassic_TLB,
  OpcLabs_EasyOpcUA_TLB, Vcl.StdCtrls,
  ComObj;

type
  TOPCThreadSender = class(TThread)
  private
  public
    WriteValueArguments1: _UAWriteValueArguments;
    Client: TEasyUAClient;
    changer: boolean;
    constructor Create();
    Destructor Destroy; override;
    procedure Execute; override;
    procedure Write;
  end;

type
  TOPCThreadReader = class(TThread)
  private
  public
    ReadArguments: _UAReadArguments;
    Client: TEasyUAClient;
    changer: boolean;
    constructor Create();
    Destructor Destroy; override;
    procedure Execute; override;
    procedure Read;
    procedure Ausgabe;
  end;

 type
  TOPCThreadChange = class(TThread)
  private
  public
    MonitoringParameters: _UAMonitoringParameters;
    Client: TEasyUAClient;
    changer: boolean;
    constructor Create();
    Destructor Destroy; override;
    procedure Execute; override;
    procedure subscribe;
    procedure Unsubscribe;
     procedure Ausgabe;
    procedure OnDataChangeNotification(ASender: TObject; Sender: OleVariant;
  const eventArgs: _EasyUADataChangeNotificationEventArgs);
  end;

type
  TForm2 = class(TForm)
    Timer1: TTimer;
    Button4: TButton;
    Button5: TButton;
    Panel1: TPanel;
    Button1: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    Button2: TButton;
    Timer2: TTimer;
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
      FSWbemLocator: OLEVariant;
    FWMIService: OLEVariant;

    GET_ADAPTER_CYCLIC : boolean;
    changer: boolean;
    MonitoringParameters: _UAMonitoringParameters;
  public
    { Public-Deklarationen }
  end;

var
  Form2: TForm2;
  threadsender : TOPCThreadSender;
  threadreader : TOPCThreadReader;
  threadchange : TOPCThreadChange;

  Rueckgabe : string;
  Rueckgabe1 : string;
  Position_Read : byte;


implementation

{$R *.dfm}






procedure GetNetworks;
var
  P: IUnknown;
  OEnum: IEnumvariant;
  iValue: LongWord;

  cnt: integer;
  f:cardinal;
  OutBufLen: ULONG;

  NumInterfaces: Cardinal;

    FWbemObjectSet: OLEVariant;
    FWbemObject: OLEVariant;
    AdapterInfo: array of TIpAdapterInfo;


    connected: integer;

    Instancename: string;
    aktiv: boolean;

begin;
  GetNumberOfInterfaces(NumInterfaces);


  OutBufLen := NumInterfaces * SizeOf(TIpAdapterInfo);
  try
    GetAdaptersInfo(@AdapterInfo[0], OutBufLen);
    try
      FWbemObject := form2.FWMIService.InstancesOf('MSNdis_MediaConnectStatus');
      try
        P := FWbemObject._NewEnum;
        try
          P.QueryInterface(IEnumvariant, OEnum);
          if FWbemObject.count > 0 then
          begin
            for cnt := 0 to FWbemObject.count - 1 do
            begin
             try
              OEnum.Next(1, FWbemObjectSet, f);
              connected := FWbemObjectSet.NdisMediaConnectStatus;
              aktiv := FWbemObjectSet.Active;
              Instancename := FWbemObjectSet.Instancename;
             finally
              FWbemObjectSet:=unassigned;
             end;
            end;
          end;
        except

        end;
      finally
        FWbemObject := Unassigned;
      end;
    except

    end;
  except

  end;
end;





procedure TOPCThreadSender.Write;
VAR
  Arguments: OleVariant;
  Results: OleVariant;
  WriteResult: _UAWriteResult;
  res: string;
  i: integer;
begin
  WriteValueArguments1.EndpointDescriptor.UrlString :=
    'opc.tcp://920-11-01-003:4840';

  if changer then
  begin
    changer := false;
    WriteValueArguments1.NodeDescriptor.NodeId.ExpandedText :=
      'ns=4;s=MAIN.Modul1_Istwert';
    WriteValueArguments1.Value := random(100);
  end
  else
  begin
    changer := true;
    WriteValueArguments1.NodeDescriptor.NodeId.ExpandedText :=
      'ns=4;s=MAIN.Modul1_Sollwert';
    WriteValueArguments1.Value := random(100);
  end;

  Arguments := VarArrayCreate([0, 0], varVariant);
  Arguments[0] := WriteValueArguments1;

  TVarData(Results).VType := vararray or varVariant;
  TVarData(Results).VArray :=
    PVarArray(Client.WriteMultipleValues(PSafeArray(TVarData(Arguments)
    .VArray)));

  for i := VarArrayLowBound(Results, 1) to VarArrayHighBound(Results, 1) do
  begin
    WriteResult := IInterface(Results[i]) as _UAWriteResult;
    if WriteResult.Succeeded then
    begin
      //beep;

    end
    else
    begin
      res := WriteValueArguments1.NodeDescriptor.NodeId.ExpandedText + ':' +
        WriteResult.Exception.GetBaseException.Message;
    end;
  end;

  Varclear(Arguments);
  // CoUAWriteValueArguments(WriteValueArguments1).Free;
end;

constructor TOPCThreadSender.Create();
begin
  inherited Create;
  if Client = nil then
  begin
    WriteValueArguments1 := CoUAWriteValueArguments.Create;
    Client := TEasyUAClient.Create(nil);
    Client.Connect;
  end;
end;

destructor TOPCThreadSender.Destroy;
begin
  inherited Destroy;
end;

procedure TOPCThreadSender.Execute();
begin
  inherited;
  CoInitializeEX(nil, COINIT_Multithreaded);
  // Namethreadfordebugging('OPCThreadSender');
  if (not terminated) then
  begin
    while not terminated do
    begin
      try
        sleep(10);
        Write;
      except

      end;
    end;
  end;

  CoUninitialize;
end;

procedure TOPCThreadReader.Ausgabe;
begin
  form2.panel1.caption:=Rueckgabe;
end;

procedure TOPCThreadReader.Read;
VAR
  Arguments: OleVariant;
  Results: OleVariant;
  WriteResult: _ValueResult;
  res: string;
  i: integer;
  Value : Variant;
begin
  ReadArguments.EndpointDescriptor.UrlString :=
    'opc.tcp://920-11-01-003:4840';

{  if changer then
  begin}
    changer := false;
    ReadArguments.NodeDescriptor.NodeId.ExpandedText :=
      'ns=4;s=MAIN.Modul1_Gewicht';
{  end
  else
  begin
    changer := true;
    ReadArguments.NodeDescriptor.NodeId.ExpandedText :=
      'ns=4;s=MAIN.Modul1_Sollwert';
  end;}
 Position_Read:=1;
  Arguments := VarArrayCreate([0, 0], varVariant);
  Arguments[0] := ReadArguments;

  Position_Read:=2;
  TVarData(Results).VType := vararray or varVariant;
  Position_Read:=3;
  TVarData(Results).VArray :=
    PVarArray(Client.readmultiplevalues(PSafeArray(TVarData(Arguments)
    .VArray)));
  Position_Read:=4;

  for i := VarArrayLowBound(Results, 1) to VarArrayHighBound(Results, 1) do
  begin
    WriteResult := IInterface(Results[i]) as _ValueResult;
    if WriteResult.Succeeded then
    begin
      Value:=WriteResult.value;
      Rueckgabe:=formatfloat('0.000',value);
      Position_Read:=5;
    end
    else
    begin
      res := ReadArguments.NodeDescriptor.NodeId.ExpandedText + ':' +
        WriteResult.Exception.GetBaseException.Message;
     Rueckgabe:=res;
     Position_Read:=6;
    end;
  end;

  Varclear(Arguments);
  // CoUAWriteValueArguments(WriteValueArguments1).Free;
end;

constructor TOPCThreadReader.Create();
begin
  inherited Create;
  if Client = nil then
  begin
    ReadArguments := CoUAReadArguments.Create;
    Client := TEasyUAClient.Create(nil);
    Client.Connect;
  end;
end;

destructor TOPCThreadReader.Destroy;
begin
  inherited Destroy;
end;

procedure TOPCThreadReader.Execute();
VAR Error:string;
begin
  inherited;
  CoInitializeEX(nil, COINIT_Multithreaded);
  // Namethreadfordebugging('OPCThreadSender');
  if (not terminated) then
  begin
    while not terminated do
    begin
      try
        sleep(10);
        try
        Read;
        except
          Error:='Read';
        end;
        synchronize(Ausgabe);
      except

      end;
    end;
  end;

  CoUninitialize;
end;


procedure TForm2.Button1Click(Sender: TObject);
begin
 threadchange := TOPCThreadChange.Create;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
 if GET_ADAPTER_CYCLIC=false then
  begin
   timer2.Enabled:=true;
   GET_ADAPTER_CYCLIC:=true;
   button2.Caption:='Read cyclic WMI Network activ';
  end
 else
  begin
    timer2.Enabled:=false;
    GET_ADAPTER_CYCLIC:=false;
    button2.Caption:='Read cyclic WMI Network inactiv';
   // clear(Listbox1.Items);
  end;
end;

procedure TForm2.Button4Click(Sender: TObject);
begin
  threadsender := TOPCThreadSender.Create;
end;

procedure TForm2.Button5Click(Sender: TObject);
begin
  timer1.Enabled:=true;
  threadreader := TOPCThreadReader.Create;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  FSWbemLocator := CreateOleObject('WbemScripting.SWbemLocator');
  FWMIService := FSWbemLocator.ConnectServer('localhost',
    'root\WMI', '', '');
end;

procedure TForm2.Timer1Timer(Sender: TObject);
begin
 panel3.Caption:=inttostr(Position_Read);
end;

procedure TForm2.Timer2Timer(Sender: TObject);
begin
  if GET_ADAPTER_CYCLIC then
   GetNetworks;
 // getAdapters(self, '', '', '', listbox1.items);
end;

procedure TOPCThreadChange.OnDataChangeNotification(ASender: TObject; Sender: OleVariant;
  const eventArgs: _EasyUADataChangeNotificationEventArgs);
var
  s: string;
  Value: Variant;
  fn: string;
begin
  try
   //if eventArgs.AttributeData.DisplayValue;
   if eventArgs.Attributedata<>nil then
    Rueckgabe1:=eventArgs.Attributedata.DisplayValue;
  except

  end;
end;



procedure TOPCThreadChange.subscribe;
var
  i: integer;
  Arguments: OleVariant;
  // Handle: Cardinal;
  HandleArray: OleVariant;
  MonitoredItemArguments: array of _EasyUAMonitoredItemArguments;
  laenge: integer;
  Position: integer;
begin
  try
    laenge:=1;
    MonitoringParameters := CoUAMonitoringParameters.Create;

    MonitoringParameters.SamplingInterval := 100;
    setlength(MonitoredItemArguments, laenge);

    for i := 0 to laenge - 1 do
    begin
      MonitoredItemArguments[i] := CoEasyUAMonitoredItemArguments.Create;
      MonitoredItemArguments[i].EndpointDescriptor.UrlString :=
         'opc.tcp://920-11-01-003:4840';
      MonitoredItemArguments[i].NodeDescriptor.NodeId.ExpandedText :=
        'ns=4;s=MAIN.Modul1_Gewicht';
      MonitoredItemArguments[i].MonitoringParameters := MonitoringParameters;
    end;

    Arguments := VarArrayCreate([0, laenge - 1], varVariant);
    for i := 0 to laenge - 1 do
    begin
      Arguments[i] := MonitoredItemArguments[i];
    end;
    TVarData(HandleArray).VType := vararray or varVariant;
    TVarData(HandleArray).VArray :=
      PVarArray(Client.SubscribeMultipleMonitoredItems
      (PSafeArray(TVarData(Arguments).VArray)));

  except

  end;

end;

procedure TOPCThreadChange.unsubscribe;
begin
  try
    Client.UnsubscribeAllMonitoredItems;
  except

  end;
end;


constructor TOPCThreadChange.Create();
begin
  inherited Create;
  if Client = nil then
  begin
    Client := TEasyUAClient.Create(nil);
    Client.OnDataChangeNotification:=OnDataChangeNotification;
    Client.Connect;
    unsubscribe;
    Subscribe;
  end;
end;

destructor TOPCThreadChange.Destroy;
begin
  inherited Destroy;
end;


procedure TOPCThreadChange.Ausgabe;
begin
  form2.panel2.caption:=Rueckgabe1;
end;

procedure TOPCThreadChange.Execute();
Var Error:string;
begin
  inherited;
  CoInitializeEX(nil, COINIT_Multithreaded);
  // Namethreadfordebugging('OPCThreadSender');
  if (not terminated) then
  begin
    while not terminated do
    begin
      try
        sleep(10);
        synchronize(Ausgabe);
      except
        Error:='change';
      end;
    end;
  end;

  CoUninitialize;
end;

end.
